﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace NeuralNumberNetwork.NumberNeuralNetwork {
    class NumberNeuralNetwork : NeuralNetwork {


        /// <summary>
        /// inputData is an Image
        /// </summary>
        /// <param name="inputData"></param>
        public override void InitializeInputNeurons(object inputData) {
            /* Bitmap bmp = (Bitmap)inputData;
             for (int x = 0; x < bmp.Size.Width; x++) {
                 for (int y = 0; y < bmp.Size.Height; y++) {
                     var activation = getActivation(bmp.GetPixel(x,y));
                     this.InputNeurons.Add(new Neuron(activation,true));
                 }
             }*/
            Random rand = new Random();
            for (int i = 0; i < 3; i++) {
                this.InputNeurons.Add(new Neuron(rand.NextDouble(), true));
            }
        }

        public double getActivation(Color c) {
            return (c.R + c.B + c.G) / (3 * 255);
        }



        public override void IntializeResultNeurons() {
            for (int i = 0; i < 2; i++) {
                ResultNeurons.Add(new Neuron("Number_"+i+"_Neuron"));
            }
        }

        public override void IntializeHiddenLayers() {
           
            List<Neuron> l2 = new List<Neuron>();
            for (int i = 0; i < 2; i++) {
               
                l2.Add(new Neuron());
            }

            foreach (var item in ResultNeurons) {
                foreach (var l in l2) {
                    item.PredeccessorNeurons.Add(l);
                }
            }

         

            foreach (var item in l2) {
                foreach (var l in InputNeurons) {
                    item.PredeccessorNeurons.Add(l);
                }
            }


        }
    }
}
